#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use strict;
use PureMessage::Version qw($PREFIX);
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Policy::Spam;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Lang;
use PureMessage::Policy::Spam::Config qw(%config);
use PureMessage::Policy::Spam::Rules;
my %vars;
our %text;
use HTML::Entities;

my @PUBLISH;
{
    (my $d  = $config{datadir})     =~ s#^\Q$PREFIX\E/##;
    (my $dd = $config{userdatadir}) =~ s#^\Q$PREFIX\E/##;
    @PUBLISH = ("$d/lock", map "$dd/$_", qw(
	dnsbl.conf
	net.conf
	spamassassin.conf
	compile.d/compiler.conf
	compile.d/destination.conf
	compile.d/heuristic.conf
	compile.d/sender.conf
	compile.d/site.conf
    ));
}

my $WIDGET = new PureMessage::Manager::Widget;

my $r = $REQUEST->get_response('PureMessage::Manager::Response::Policy::Spam',
                               'stderr_to_stdout' =>1
                              );

$r->add_help(text => "Help", tab => "pol", page => "mgr_pol_spamopt" );

$r->{debug} =0;

my $rules = PureMessage::Policy::Spam::Rules->new;
my $backend = $vars{backend} = $in{b} || 'spam';
my $plugin_data = $rules->getgroup($backend);

my $display_name = $plugin_data->{Desc} ? " : $plugin_data->{Desc} " : "";
$r->title(&text('options_title',$display_name));

eval {
    require PureMessage::Manager::Response::ServerGroups::Publications;
    $r->print(
        PureMessage::Manager::Response::ServerGroups::Publications::Publish(
	    \@PUBLISH,
            "AntiSpam Options"
	)
	. "<br>"
    ); 
};

unless ($r->load_backend($backend)) {
    $r->raise_error('error_options_unable_to_get_conf',encode_entities($backend,'&<>"\/\''));
    $r->error_dlg;
    $r->send;
    exit;
}

if ($in{save}) {
    $r->load_backend_cgi_input(\%in);
}
else {
    $r->load_backend_configuration;
}

if ($in{save}) {
    if ($r->save_options) {
	# Rebuild the summary database, so that when we re-display the rules,
	# we don't display stale data.
	$rules->refresh;

	$r->print_notification(text('spam_changes_saved'));

	# allow PM::Service::Config to not exist, like
	# for instance, if they have an older PM-Utils
	# without it.
	eval {
	    require PureMessage::Service::Config;
	    PureMessage::Service::Config::stale('milter');
	};
	 
	PureMessage::Policy::Spam::Config::refresh;

	if ($backend ne 'spam') {
	      $backend = 'spam';
	      unless ($r->load_backend($backend)) {
		      $r->raise_error('error_options_unable_to_get_conf',$backend);
		      $r->error_dlg;
		      $r->send;
		      exit;
	     }
	     $r->load_backend_configuration;
	     $r->title(&text('options_title',''));
	}
    } 
}

my $DATA; # data to send to the template when it's rendered
$DATA->{uc($_)} = $plugin_data->{$_} foreach keys %$plugin_data;

if ($backend eq 'spam') {
    my %display = map { $_ => 1 } $r->get_valid_backends;

    # it's the main page, get the plugin data
    my @plugins;
    foreach my $group ($rules->groupnames) {
	next unless $display{$group};

	my $pdata = $rules->getgroup($group);
	my %plugin = (p_PLUGIN => $group);
	$plugin{"p_\U$_"} = $pdata->{$_} foreach keys %$pdata;
	push(@plugins, \%plugin);
    }
    @plugins = sort { $a->{p_ORDER} <=> $b->{p_ORDER} } @plugins;

    $DATA->{PLUGINS} = \@plugins;
    $DATA->{SAVE_BUTTON} = button({
	type => 'image',
	name => 'save',
	text => 'Save',
	alt  => 'Save',
	icon => 'save',
    });
    $DATA->{PLUGIN_HEADER} = $r->ThemeSectionHeader(
	title => 'Anti-Spam Feature Groups'
    )->output;
    $DATA->{PLUGIN_FOOTER} = $r->ThemeSectionFooter->output;

    # add in a hook here if the plugin#.dnsbl.relay_tests_only is on or off
    if ($config{plugin}{dnsbl}{relay_tests_only}) {
	$r->print_notification(text('relay_tests_only_set'))
	    if text('relay_tests_only_set') ne 'relay_tests_only_set';
    }
    else {
	$r->print_notification(text('relay_tests_only_not_set'))
	    if text('relay_tests_only_not_set') ne 'relay_tests_only_not_set';
    }
}
else {
    # it's a plugin page, flip to the plugin toolbar
}

$r->add_backend_template($DATA);
$r->send;
